/*****************************************************************************************
   
   Copyright (c) Microsoft Corporation. All rights reserved.

   Use of this code sample is subject to the terms of the Microsoft
   Public License, a copy of which should always be distributed with
   this file.  You can also access a copy of this license agreement at:
   http://www.microsoft.com/opensource/licenses.mspx#Ms-PL

 ****************************************************************************************/
using System;

namespace Microsoft.CSA.FeedSync.FeedSyncLibrary
{
    public interface IFeedSyncItem
    {
        Microsoft.CSA.FeedSync.FeedSyncLibrary.Sync Sync { get; set;}
        System.Xml.XmlElement XmlElement { get; }
        System.Xml.XmlNamespaceManager XmlNamespaceManager { get; }

        void Update(System.DateTime? i_WhenDateTime, string i_By);
        void ResolveConflicts(System.DateTime? i_WhenDateTime, string i_By);
        void Delete(System.DateTime? i_WhenDateTime, string i_By);
        
        Microsoft.CSA.FeedSync.FeedSyncLibrary.IFeedSyncItem Clone();
        Microsoft.CSA.FeedSync.FeedSyncLibrary.Sync Initialize(System.Xml.XmlElement i_XmlElement, System.Xml.XmlNamespaceManager i_XmlNamespaceManager);
    }
}
