/*****************************************************************************************
   
   Copyright (c) Microsoft Corporation. All rights reserved.

   Use of this code sample is subject to the terms of the Microsoft
   Public License, a copy of which should always be distributed with
   this file.  You can also access a copy of this license agreement at:
   http://www.microsoft.com/opensource/licenses.mspx#Ms-PL

 ****************************************************************************************/
using System;

namespace Microsoft.CSA.FeedSync.SimpleFeedBindingsLibrary
{
    public class Constants
    {
        public const string SIMPLE_FEED_BINDINGS_XML_NAMESPACE_PREFIX = "sfb";
        public const string SIMPLE_FEED_BINDINGS_XML_NAMESPACE_URI = "http://feedsync.org/2008/namespaces/binding";
        public const string SIMPLE_FEED_BINDINGS_LAST_COMPATIBLE_VERSION = "0.93";
        public const string SIMPLE_FEED_BINDINGS_CURRENT_VERSION = "0.93";

        public const string DEFAULT_TITLE_ELEMENT_NAME = "title";
        public const string DEFAULT_DESCRIPTION_ELEMENT_NAME = "description";

        public const string BINDING_ELEMENT_NAME = "binding";
        public const string NAMESPACE_ELEMENT_NAME = "namespace";
        public const string FIELD_ELEMENT_NAME = "field";
        public const string PICKLIST_ELEMENT_NAME = "picklist";
        public const string PICKLIST_ITEM_ELEMENT_NAME = "listitem";
        public const string FIELD_EXTENSION_ELEMENT_NAME = "fieldextension";
        public const string REFERENCE_ELEMENT_NAME = "reference";

        public const string DATE_STRING_FORMAT = "yyyy-MM-ddTHH:mm:ssZ";

        public const string VERSION_ATTRIBUTE = "version";
        public const string ID_ATTRIBUTE = "id";
        public const string NAME_ATTRIBUTE = "name";
        public const string TITLE_ATTRIBUTE = "title";
        public const string DESCRIPTION_ATTRIBUTE = "description";
        public const string LOCAL_PREFIX_ATTRIBUTE = "localprefix";
        public const string URI_ATTRIBUTE = "uri";
        public const string ELEMENT_ATTRIBUTE = "element";
        public const string LABEL_ATTRIBUTE = "label";
        public const string CONTENT_TYPE_ATTRIBUTE = "contenttype";
        public const string TYPE_ATTRIBUTE = "type";
        public const string DEFAULT_VALUE_ATTRIBUTE = "defaultvalue";
        public const string ARRAY_ATTRIBUTE = "array";
        public const string REQUIRED_ATTRIBUTE = "required";
        public const string HIDDEN_ATTRIBUTE = "hidden";
        public const string PICKLIST_ID_ATTRIBUTE = "picklist";
        public const string READ_ONLY_ATTRIBUTE = "readonly";
        public const string MULTILINE_ATTRIBUTE = "multiline";

        public const string TEXT_CONTENT_TYPE = "text";
        public const string XML_CONTENT_TYPE = "text/xml";
        public const string HTML_CONTENT_TYPE = "text/html";
        public const string XHTML_CONTENT_TYPE = "application/xhtml+xml";

        public const string NONE_TYPE = "none";
        public const string DATETIME_TYPE = "datetime";
        public const string BOOLEAN_TYPE = "boolean";
        public const string NUMBER_TYPE = "number";
        public const string FLOATINGPOINT_TYPE = "floatingpoint";
    }
}
